{$DEFINE LITE}
unit ElReg;

interface

uses

{$IFNDEF LITE}
Classes, SysUtils, DsgnIntf, Controls, ElTree, frmItemsProp,
ElHeader, ElURLLabel, frmSectProp, DragDrop, FormCtlProp, ElPanel,
ElGraphs, ElClock, ElImgLst, ElPopBtn, MlCapProp, ElColorMap, ElCaption,
frmColorMapItems, frmFormPers, ElOpts, ElOneInst, ElDice, FormPers, ElGauge,
ColorCombo, BiProgr, ElClipMon, Histogrm, ElStatBar, ElIni, MRU, ElHook,
ElTray, DailyTip, ElToolBar, ElTBDsgn, ElCalendar, ElCalendDlg, ElSpin, ElTreeCombo;
{$ELSE}
Classes, SysUtils, DsgnIntf, ElTree, frmItemsProp, ElHeader, frmSectProp;
{$ENDIF}

procedure Register;

implementation

{$IFNDEF LITE}
type TMRUCollectionEditor = class (TDefaultEditor)
       public
         procedure EditProperty(PropertyEditor: TPropertyEditor; var Continue, FreeEditor: Boolean); override;
     end;

procedure TMRUCollectionEditor.EditProperty(PropertyEditor: TPropertyEditor;
          var Continue, FreeEditor: Boolean);
var
  PropName: string;
begin
  PropName := PropertyEditor. GetName;
  if (CompareText(PropName, 'SECTIONS') = 0) then
  begin
    PropertyEditor.Edit;
    Continue := False;
  end;
end;
{$ENDIF}

procedure Register;
begin
  RegisterComponents('EldoS', [
  {$IFDEF LITE}
    TElHeader, TElTree
  {$ELSE}
    TElHeader, TElTree, TElDragDrop, TElDropTarget, TElURLLabel, TElGraph, TElPanel,
                    TElClock, TElColorMap, TElImageList,
                    TElSpeedButton, TElPopupButton, TElDice, TElDicePanel, TElGauge,
                    TElColorCombo, TELBiProgressBar, TElClipboardMonitor, TElHistogram,
                    TElOneInstance, TElStatusBar, TElIniFile, TElMRU, TElHook,
                    TElTrayIcon, TElFormPersist, TElFormCaption, TElDailyTipDialog,
                    TElToolBar, TElCalendar, TElCalendarDialog, TElSpinEdit, TElTreeCombo
  {$ENDIF}]);
  {$IFNDEF LITE}
  RegisterNoIcon([TElToolButton]);
  RegisterClass(TElToolButton);
  RegisterPropertyEditor(TypeInfo(TCaption), TElPopupButton, 'Caption',
                         TMlCaptionProperty);
  RegisterPropertyEditor(TypeInfo(TElColorEntries), TElColorMap, 'ItemsList',
                         TColorMapItemsProperty);
  RegisterPropertyEditor(TypeInfo(TWinControl), TElHook, 'Control', TFormCtlProperty);
  RegisterPropertyEditor(TypeInfo(TElStoredProps), TElFormPersist, 'StoredProps', TPropListProperty);
  RegisterComponentEditor(TElMRU, TMRUCollectionEditor);
  RegisterComponentEditor(TElToolBar, TElToolBarEditor);
  RegisterComponentEditor(TElFormPersist, TElPropListEditor);
  {$ENDIF}
  RegisterPropertyEditor(TypeInfo(TElTreeItems), TCustomElTree, 'Items',
                         TElTreeItemsProperty);
  RegisterPropertyEditor(TypeInfo(TElHeaderSections), nil, 'Items',
                         TElSectionsProperty);
end;

end.
