unit ElStrUtils;

interface

function IntToStrPad(value : integer; MinSize : integer) : string;

function OEMToStr(S : String) : string;
function StrToOEM(S : String) : string;

function MessageRes(Txt: Integer; Title : PChar; TextType: Word; Sounds : boolean): Integer;

function replace(var Str : string; SourceString,DestString:string):boolean;

function ExtractWord(str : string; n:integer):string;

function FstNonSpace(str : string):integer;

function NextWordBegin(str : string; CurrentPos : integer): integer;

function LastPos(SubStr : string; Strn:String): integer;
{ Returns the beginning of the last substring in a string }

Function LineIsEmpty( str : string ):boolean;
// Returns true, if line doesn't contain any characters except, probably, spaces and tabs

function CompleteLine(Str:String; FLen:integer; symb:char):string;
{ completes a string with some chars }

function PrefixLine(Str:string; FLen:integer; symb:char):string;

Function MakeString(FLen : Integer; Symb : char ):string;
// creates a new string, filled with specified chars

function H2D(const S: string): integer;

function Bin2Int(S : string) : integer;

function Bin2IntDef(S : string; Default : integer) : integer;

function Data2Str (Buffer : pointer; BufLen : integer) : string;
function Str2Data (S : String; var Buffer : pointer; var BufLen : integer) : boolean;

function IsDigit (ch : char) : boolean;
function IsDigitStr(const S : String) : boolean;
function IsAlpha (ch : char) : boolean;
function IsAlphaStr(const S : String) : boolean;
function IsIdentStr(const S : String) : boolean;

function ExtractStr(var S : String; SPos, SLen : integer) : string;

implementation

uses Windows, SysUtils, Consts;

type PArr = ^TByteArr;
     TByteArr = array [0..$7FFFFFFE] of byte;

function OEMToStr(S : String) : string;
begin
  SetLength(Result, Length(S));
  if Length(S) > 0 then OEMToChar(PChar(S), PChar(result));
end;

function StrToOEM(S : String) : string;
begin
  SetLength(Result, Length(S));
  if Length(S) > 0 then CharToOEM(PChar(S), PChar(result));
end;

function ExtractStr(var S : String; SPos, SLen : integer) : string;
begin
  result := Copy(S, SPos, SLen);
  Delete (S, SPos, SLen);
end;

function Data2Str (Buffer : pointer; BufLen : integer) : string;
var p : PArr;
    i : integer;
begin
  P := PArr(Buffer);
  result := IntToHex(ord('E'), 2) + IntToHex(ord('L'), 2) + ' ' + IntToHex(BufLen, 1) + ' ';
  for i := 0 to BufLen - 1 do
    result := result + IntToHex(P[i], 2) + ' ';
end;

function Str2Data (S : String; var Buffer : pointer; var BufLen : integer) : boolean;
var p : PArr;
    i, j : integer;
    S1 : string;
    b : Boolean;
begin
  result := false;
  BufLen := -1;
  Buffer := nil;
  if pos('454C', S)<>1 then exit;
  Delete(S, 1, 5);
  S1 := ExtractStr(S, 1, Pos(' ', S) - 1);
  Delete(S,1,1);
  if S1 = '' then exit;
  try
    j := H2D(S1);
  except
    exit;
  end;
  GetMem(Buffer, j);
  BufLen := j;
  p := PArr(Buffer);
  try
    for i := 0 to J - 1 do
    begin
      if Pos(#32, S) >0 then
      begin
        S1 := ExtractStr(S, 1, Pos(#32, S)-1);
        delete(S, 1, 1);
        b := False;
      end else
      begin
        S1 := S;
        b := true;
      end;
      P[i] := H2D(S1);
      if b and (i < j -1) then break;
    end;
    result :=  i >= j;
  except
    result := False;
  end;
end;

function IsIdentStr(const S : String) : boolean;
var i, j : integer;
    ch : char;
begin
  j := length(S);
  result := false;
  if (J = 0) or (not (IsAlpha(s[1]))) then exit;
  for i := 2 to j do
  begin
    ch := S[i];
    if ((ch >= 'A') and (ch <= 'Z'))
    or ((ch >= 'a') and (ch <= 'z'))
    or ((ch >= '0') and (ch <= '9')) then else exit;
  end;
  result := true;
end;

function IsAlpha (ch : char) : boolean;
begin
  result := ((ch >= 'A') and (ch <= 'Z')) or ((ch >= 'a') and (ch <= 'z'));
end;

function IsAlphaStr(const S : String) : boolean;
var i, j : integer;
    ch : char;
begin
  j := length(S);
  result := false;
  for i := 1 to j do
  begin
    ch := S[i];
    if ((ch >= 'A') and (ch <= 'Z')) or ((ch >= 'a') and (ch <= 'z')) then else exit;
  end;
  result := true;
end;

function IsDigit (ch : char) : boolean;
begin
  result := (ch >= '0') and (ch <= '9');
end;

function IsDigitStr(const S : String) : boolean;
var i, j : integer;
begin
  j := length(S);
  result := false;
  for i := 1 to j do
  begin
    if (S[i]<'0') or (S[i]>'9') then exit;
  end;
  result := true;
end;

function H2D(const S: string): integer;
var
  HexStr: string;
begin
  if Pos('$', S) = 0 then HexStr := '$' + S
  else HexStr := S;
  Result := StrToIntDef(HexStr, 0);
end;

function MessageRes;
begin
  if Sounds then MessageBeep( TextType and
                 (mb_IconAsterisk or mb_IconExclamation or mb_IconHand or mb_IconQuestion or mb_Ok));
  result:=MessageBox(0, PChar(LoadStr(TXT)), Title, TextType);
end;

function replace;
var i:integer;
begin
  i:=pos(SourceString,Str);
  if i=0 then
  begin
    result:=false;
    exit;
  end;
  Delete(Str,i,Length(SourceString));
  Insert(DestString,Str,i);
  result:=true;
end;

function extractword(str : string; n : integer) : string;
var
    count : integer;
    i : integer;
    len : integer;
    done : boolean;
    retstr : string;

begin
  retstr := '';
  len := length(str);
  count := 0;
  i := 1;
  done := false;
  while (i <= len) and (not done) do
    begin
    while ((i <= len) and ((str[i] = #32) or (str[i] = #9) or (str[i] = ';'))) do
      inc(i);
    if i <= len then
      inc(count);
    if count = n then
      begin
      setstring(retstr,nil,0);
      if (i > 1) then
        if str[i-1] = ';' then
          retstr := ';';
      while ((i <= len) and ((str[i] <> #32) and (str[i] <> #9) and (str[i] <> ';'))) do
        begin
        setlength(retstr,length(retstr)+1);
        retstr[ord(length(retstr))] := str[i];
        inc(i);
        end;
      done := true;
      end
    else
      while ((i <= len) and ((str[i] <> #32) and (str[i] <> #9) and (str[i] <> ';'))) do
        inc(i);
    end;
  result := retstr;
end;

function FstNonSpace(str:string):integer;
var //P : PChar;
    i : integer;

begin
  i:=1;
  while (i<Length(Str)) and ((str[i]=#32) or (str[i]=#9)) do inc(i);
  if i=Length(Str) then result:=-1 else result:=i;
end;

function NextWordBegin(str:string; CurrentPos : integer): integer;
var i : integer;
begin
  i:=CurrentPos;
  while (i<Length(str)) and ((Str[i]=#32) or (Str[i]=#9)) do inc(i);
  if i=Length(str) then result:=-1 else result:=i;
end;

Function LastPos(SubStr:string; Strn:String):integer;
var i,
    j  : integer;
    ls, // total length of substring
    ld  // length of string
       : integer;

begin
 result := 0;
 ls := Length(SubStr);
 ld := Length(Strn);
 if (ls > ld) or (ls = 0) or (ld = 0) then exit;
 for i := ld downto ls do
 begin
   j := ls;
   while j >= 1 do
   begin
     if Strn[i - ls + j] <> SubStr[j] then break;
     dec(j);
   end;
   if j = 0 then
   begin
     result := i - ls + 1;
     exit;
   end;
 end;
 (*s:=Strn;
 n:=0;
 while Pos(Substr,s)>0 do
 begin
  n:=n+Pos(Substr,s);
  s:=Copy(Strn, n+1, Length(Strn));
 end;
 if n=0 then n:=-1;
 Result:=n;*)
end;

Function LineIsEmpty( str : string ):boolean;
begin
  result:=FstNonSpace( str )=-1;
end;

function PrefixLine(Str:string; FLen:integer; symb:char):string;
begin
  if FLen = 0 then
  begin
    result := Str;
    exit;
  end;
  SetLength(Result, FLen);
  FillMemory(PChar(result), FLen, byte(symb));
  result := Result + Str; 
end;

function CompleteLine(Str:String; FLen:integer; symb:char):string;
var S:String;
    i,j:integer;
begin
 s:=Str;
 if Length(s)>=FLen then
 begin
  result:=s;
  Exit;
 end;
 j:=Length(S);
 SetLength(S, FLen);
 for i:=j to FLen do
 begin
  S[i]:=symb;
 end;
 result:=s;
end;

Function MakeString(FLen : Integer; Symb : char ):string;
begin
  result:='';
  CompleteLine(result, FLen, Symb);
end;

function IntToStrPad(value : integer; MinSize : integer) : String;
begin
  result := IntToStr(Value);
  while Length(result) < MinSize do Result := '0' + result;
end;

function Bin2IntDef(S : string; Default : integer) : integer;
begin
  try
    result := Bin2Int(S);
  except
    result := Default;
  end;
end;

function Bin2Int(S : string) : integer;
var i,l  : integer;
begin
  l := length(S);
  result := 0;
  for i := 1 to l do
  begin
    result := (result shl 1);
    if s[i] = '1' then result := result and ($ffffffff) else
{$IFNDEF VER90}
    if s[i] <>'0' then raise EConvertError.CreateFmt(SInvalidInteger, [S]);
{$ELSE}
    if s[i] <>'0' then raise EConvertError.CreateResFmt(SInvalidInteger, [S]);
{$ENDIF}
  end;
end;

end.

